package de.jottyfan.minecraft.quickiefabric.mixin;

import org.spongepowered.asm.mixin.Mixin;
import org.spongepowered.asm.mixin.injection.At;
import org.spongepowered.asm.mixin.injection.Inject;
import org.spongepowered.asm.mixin.injection.callback.CallbackInfo;

import de.jottyfan.minecraft.quickiefabric.init.RegistryManager;
import net.minecraft.world.biome.GenerationSettings;
import net.minecraft.world.gen.GenerationStep;
import net.minecraft.world.gen.feature.DefaultBiomeFeatures;
import net.minecraft.world.gen.feature.PlacedFeature;

/**
 * 
 * @author jotty
 *
 */
@Mixin(DefaultBiomeFeatures.class)
public class FeatureConfigMixin {
	
	@Inject(at = @At("TAIL"), method = "addMineables(Lnet/minecraft/world/biome/GenerationSettings$Builder;)V")
  private static void addMineables(GenerationSettings.Builder builder, CallbackInfo ci) {
		for (PlacedFeature configuredFeature : RegistryManager.FEATURE_QUICKIE_ORES) {
			builder.feature(GenerationStep.Feature.UNDERGROUND_ORES, configuredFeature);
		}
  }
	
	@Inject(at = @At("TAIL"), method = "addNetherMineables(Lnet/minecraft/world/biome/GenerationSettings$Builder;)V")
  private static void addNetherMineables(GenerationSettings.Builder builder, CallbackInfo ci) {
		for (PlacedFeature configuredFeature : RegistryManager.FEATURE_QUICKIE_NETHERORES) {
			builder.feature(GenerationStep.Feature.UNDERGROUND_ORES, configuredFeature);
		}
  }
}
