package de.jottyfan.minecraft.quickiefabric.tools;

import java.util.List;

import com.google.common.collect.Lists;

import de.jottyfan.minecraft.quickiefabric.init.RegistryManager;
import net.fabricmc.fabric.api.tool.attribute.v1.ToolManager;
import net.minecraft.block.Block;
import net.minecraft.block.BlockState;
import net.minecraft.item.HoeItem;
import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import net.minecraft.item.ItemUsageContext;
import net.minecraft.item.ToolMaterials;
import net.minecraft.util.ActionResult;
import net.minecraft.util.hit.BlockHitResult;
import net.minecraft.util.math.Direction;
import net.minecraft.util.math.Vec3i;

/**
 * 
 * @author jotty
 *
 */
public class ToolSpeedpowderHoe extends HoeItem implements ToolRangeable {
	public static final Integer DEFAULT_PLOW_RANGE = 4;
	public HarvestRange range;

	public ToolSpeedpowderHoe() {
		super(ToolMaterials.DIAMOND, 4, 2.0f, new Item.Settings().group(RegistryManager.QUICKIEFABRIC_GROUP));
		this.range = new HarvestRange(DEFAULT_PLOW_RANGE);
	}

	@Override
	public ActionResult useOnBlock(ItemUsageContext context) {
		ActionResult res = super.useOnBlock(context);
		if (!ActionResult.PASS.equals(res)) {
			for (int x = -this.range.getxRange(); x <= this.range.getxRange(); x++) {
				for (int y = -this.range.getyRange(); y <= this.range.getyRange(); y++) {
					for (int z = -this.range.getzRange(); z <= this.range.getzRange(); z++) {
						BlockHitResult bhr = new BlockHitResult(context.getHitPos(), Direction.UP,
								context.getBlockPos().add(new Vec3i(x, y, z)), isDamageable());
						ItemUsageContext ctx = new ItemUsageContext(context.getPlayer(), context.getHand(), bhr);
						super.useOnBlock(ctx);
					}
				}
			}
		}
		return res;
	}

	@Override
	public HarvestRange getRange(ItemStack stack) {
		// TODO: get range from stack
		return range;
	}

	@Override
	public boolean canBreakNeighbors(BlockState blockState) {
		return ToolManager.handleIsEffectiveOn(blockState, new ItemStack(this), null);
	}


	@Override
	public List<Block> getBlockList(Block block) {
		return Lists.newArrayList(block);
	}

//	@Override
//	public ActionResult<ItemStack> onItemRightClick(World worldIn, PlayerEntity playerIn, Hand handIn) {
//		CommonToolCode.onItemRightClick(worldIn, playerIn, handIn);
//		return super.onItemRightClick(worldIn, playerIn, handIn);
//	}
//
//	@Override
//	public void addInformation(ItemStack stack, World worldIn, List<ITextComponent> tooltip, ITooltipFlag flagIn) {
//		CommonToolCode.addInformation(stack, worldIn, tooltip, flagIn);
//		super.addInformation(stack, worldIn, tooltip, flagIn);
//	}
}
